const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const subjects = sequelize.define(
    'subjects',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

code: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subjects.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







    db.subjects.hasMany(db.textbooks, {
      as: 'textbooks_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });



    db.subjects.hasMany(db.curriculum_standards, {
      as: 'curriculum_standards_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });



    db.subjects.hasMany(db.question_banks, {
      as: 'question_banks_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });




    db.subjects.hasMany(db.tests, {
      as: 'tests_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });















//end loop






    db.subjects.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subjects.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return subjects;
};


